<template>
  <div class="app-container">
      <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
        <el-form-item label="瓦力ID">
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.cusUid" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="日期时间">
          <el-date-picker
            v-model="queryParams.beginCreateTime"
            type="datetime"
            placeholder="开始日期"
            class="baseInput"
            format="yyyy-MM-dd HH"
            value-format="yyyy-MM-dd HH"
            style="width: 200px;"
          >
          </el-date-picker>
          <span> - </span>
          <el-date-picker
            v-model="queryParams.endCreateTime"
            type="datetime"
            placeholder="结束日期"
            class="baseInput"
            format="yyyy-MM-dd HH"
            value-format="yyyy-MM-dd HH"
            style="width: 200px;"
          >
          </el-date-picker>
        </el-form-item>
        <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">筛选</el-button>
        <el-button class="filter-item" type="primary" icon="el-icon-s-flag" @click="exportData">导出</el-button>
        <el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit"  justify="end">添加</el-button>
      </el-form>
    <el-table :data="tableData" style="width:100%" class="show_table" >
      <el-table-column label="瓦力ID" style="width:2%" align="center">
        <template slot-scope="scope">
          <span>{{scope.row.cusUid}}</span>
        </template>
      </el-table-column>
      <el-table-column label="获得赠币数量" style="width:10%" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.coins }}</span>
        </template>
      </el-table-column>
      <el-table-column label="事由" style="width:30%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.remark }}</span>
        </template>
      </el-table-column>
      <el-table-column label="时间" style="width:4%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作人员" style="width:4%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.operName }}</span>
        </template>
      </el-table-column>

    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>


    <!-- 添加或修改对话框 -->
    <el-dialog :title="title"  :close-on-click-modal="false" :visible.sync="dialogFormVisible" width="30%" :before-close="sortHandleClose" center>
      <el-form :model="form" :rules="rules" ref="form" label-width="auto">
        <el-form-item label="瓦力ID" :label-width="formLabelWidth" prop="openId">
          <el-input v-model="form.openId" style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="添加游戏币数量" :label-width="formLabelWidth" prop="coins">
          <el-input v-model="form.coins" style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="事由" :label-width="formLabelWidth" prop="remark">
          <el-input type="textarea" v-model="form.remark" auto-complete="new-password" style="width:80%" maxlength="50" show-word-limit :autosize="{ minRows: 5, maxRows: 5 }"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
    import {dateFormat} from "@/utils/webUtils.js";
    import {getAddCoinList,addCoins} from "@/api/addCoins";
    import {
      export_json_to_excel
    } from "@/vendor/Export2Excel";
    export default {
        created() {
            this.getAddCoinLists();
        },

        data() {
            return {

                tableData: [],
                form: {
                    openId: null,
                    coins: null,
                    remark: null
                },
                queryParams:{
                  cusUid: "",
                  beginCreateTime: dateFormat("YYYY-mm-dd 00", new Date()),
                  endCreateTime: dateFormat("YYYY-mm-dd 23", new Date()),
                },
                title: null,
                currentPage: 1,
                total: null,
                pageSize: 40,
                orderByDescColumn: "", // 降序字段
                orderByAscColumn: "", // 升序字段
                formLabelWidth: "120px", //弹框的label边框
                dialogFormVisible: false,
                atlasFormVisible: false,
                pictureFormVisible: false,
                atlasDialogPictureVisible: false,//当前分类图集列表
                isSortAdd: false,
                isEditForm: false,
                rules: {
                    openId: [
                        {required: true, message: '用户ID不能为空', trigger: 'blur'},
                    ],
                    coins: [
                        {required: true, message: '赠币数量不能为空', trigger: 'blur'},
                        {pattern: /^[0-9]\d*$/, message: '赠币数量数字格式不对'},
                    ],
                    remark: [
                        {required: true, message: '事由不能为空', trigger: 'blur'},
                    ]
                }
            };
        },

        methods: {
            getAddCoinLists: function() {
                this.queryParams.currentPage = this.currentPage;
                this.queryParams.pageSize = this.pageSize;
                this.queryParams.orderByDescColumn = this.orderByDescColumn
                this.queryParams.orderByAscColumn = this.orderByAscColumn
                getAddCoinList(this.queryParams).then(response => {
                    this.tableData = response.data.records;
                    this.currentPage = response.data.current;
                    this.pageSize = response.data.size;
                    this.total = response.data.total;
                });
            },
            getFormObject: function() {
                var formObject = {
                    openId: null,
                    coins: null,
                    remark: null
                };
                return formObject;
            },
            /**
             * 翻页事件
             */
            handleSizeChange(val) {
                this.pageSize = val;
                this.getAddCoinLists();
            },
            //改变页码
            handleCurrentChange(val) {
                this.currentPage = val;
                this.getAddCoinLists();
            },
            sortHandleClose(){
                this.dialogFormVisible = false;
                this.$refs.form.clearValidate();
                this.getAddCoinLists();
            },
            handleFind: function() {
              this.currentPage = 1
              this.getAddCoinLists();
            },
            //点击新增
            handleAdd: function() {
                this.title = "添加游戏币"
                this.isSortAdd = true
                this.dialogFormVisible = true;
                this.form = this.getFormObject();
                this.isEditForm = false;
            },

            submitForm: function() {
                this.$refs.form.validate((valid) => {
                    if(!valid) {
                        console.log("校验出错")
                    } else {
                            addCoins(this.form).then(response => {
                                if (response.code == this.$ECode.SUCCESS) {
                                    this.$commonUtil.message.success(response.message)
                                } else {
                                    this.$commonUtil.message.error(response.data)
                                }
                                this.dialogFormVisible = false;
                                this.getAddCoinLists();
                            });
                    }
                })
            },

          // 导出excel数据
          exportData() {
            // 表头对应关系
            const headers = {
              '瓦力ID': 'cusUid',
              '获得赠币数量': 'coins',
              '事由': 'remark',
              '时间': 'createTime',
              '操作人员': 'operName',
            }
            this.queryParams.currentPage = 1;
            this.queryParams.pageSize = -1;
            this.queryParams.orderByDescColumn = this.orderByDescColumn
            this.queryParams.orderByAscColumn = this.orderByAscColumn
            getAddCoinList(this.queryParams).then(response => {
              const data = this.formatJson(headers, response.data.records)
              export_json_to_excel(Object.keys(headers), data, '添加游戏币')
            });
          },
          // 该方法负责将数组转化成二维数组
          formatJson(headers, rows) {
            return rows.map(item => {
              return Object.keys(headers).map(key => {
                return item[headers[key]]
              })
            })
          },
        }
    }
</script>

<style scoped>

</style>
